# LocaleRuns Class Reference

The `LocaleRuns` class associates pointers to `Locale` objects with runs of text. More...

`#include <RunArrays.h>`

Inheritance diagram for LocaleRuns:

## Public Member Functions
| LocaleRuns (const Locale **locales, const le_int32 *limits, le_int32 count)
| Construct a `LocaleRuns` object from pre-existing arrays of locales and limit indices.
| LocaleRuns (le_int32 initialCapacity)
| Construct an empty `LocaleRuns` object.
virtual | ~LocaleRuns ()
| The destructor; virtual so that subclass destructors are invoked as well.
const Locale * | getLocale (le_int32 run) const
| Get the `Locale` object assoicated with the given run of text.
le_int32 | add (const Locale *locale, le_int32 limit)
| Add a `Locale` and limit index pair to the data arrays and return the run index where the data was stored.
virtual UClassID | getDynamicClassID () const
| ICU "poor man's RTTI", returns a UClassID for the actual class.
## Static Public Member Functions
static UClassID | getStaticClassID ()
| ICU "poor man's RTTI", returns a UClassID for this class.
## Protected Member Functions
virtual void | init (le_int32 capacity)
| Create a data array with the given initial size.
virtual void | grow (le_int32 capacity)
| Grow a data array to the given initial size.
## Protected Attributes
const Locale ** | fLocales

## Detailed Description

The `LocaleRuns` class associates pointers to `Locale` objects with runs of text.

Stable:
  ICU 3.2

Definition at line 407 of file RunArrays.h.

## Constructor & Destructor Documentation

LocaleRuns::LocaleRuns | ( | const Locale ** | locales,
|  | const le_int32 * | limits,
|  | le_int32 | count |
| ) |  |  | `[inline]`

Construct a `LocaleRuns` object from pre-existing arrays of locales and limit indices.

Parameters:

  | locales | is the address of an array of pointers to `Locale` objects. This array, and the `Locale` objects to which it points, must remain valid until the `LocaleRuns` object is destroyed.
  | limits | is the address of an array of limit indices. This array must remain valid until the `LocaleRuns` object is destroyed.
  | count | is the number of entries in the two arrays.

Stable:
  ICU 3.2

Definition at line 535 of file RunArrays.h.

References LocaleRuns().

Referenced by LocaleRuns().

LocaleRuns::LocaleRuns | ( | le_int32 | initialCapacity | ) |

Construct an empty `LocaleRuns` object.

Clients can add locale and limit indices arrays using the `add` method.

Parameters:

  | initialCapacity | is the initial size of the locale and limit indices arrays. If this value is zero, no arrays will be allocated.

See also:
  add

Stable:
  ICU 3.2

virtual LocaleRuns::~LocaleRuns | ( |  | ) | `[virtual]`

The destructor; virtual so that subclass destructors are invoked as well.

Stable:
  ICU 3.2

## Member Function Documentation

le_int32 LocaleRuns::add | ( | const Locale * | locale,
|  | le_int32 | limit |
| ) |  |  |

Add a `Locale` and limit index pair to the data arrays and return the run index where the data was stored.

This method calls `RunArray::add(limit)` which will create or grow the arrays as needed.

If the `LocaleRuns` object was created with a client-supplied locale and limit indices arrays, this method will return a run index of -1.

Subclasses should not override this method. Rather they should provide a new `add` method which takes a locale and a limit index along with whatever other data they implement. The new `add` method should first call this method to grow the font and limit indices arrays, and use the returned run index to store data their own arrays.

Parameters:

  | locale | is the address of the `Locale` to add. This object must remain valid until the `LocaleRuns` object is destroyed.
  | limit | is the limit index to add

Returns:
  the run index where the locale and limit index were stored, or -1 if the data cannot be stored.

Stable:
  ICU 3.2

virtual UClassID LocaleRuns::getDynamicClassID | ( | void |  | ) | const`[inline, virtual]`

ICU "poor man's RTTI", returns a UClassID for the actual class.

Stable:
  ICU 3.2

Reimplemented from RunArray.

Definition at line 499 of file RunArrays.h.

References RunArray::getStaticClassID().

const Locale* LocaleRuns::getLocale | ( | le_int32 | run | ) | const

Get the `Locale` object assoicated with the given run of text.

Use `RunArray::getLimit(run)` to get the corresponding limit index.

Parameters:

  | run | is the index into the font and limit indices arrays.

Returns:
  the `Locale` associated with the given text run.

See also:
  RunArray::getLimit

Stable:
  ICU 3.2

static UClassID LocaleRuns::getStaticClassID | ( | void |  | ) | `[inline, static]`

ICU "poor man's RTTI", returns a UClassID for this class.

Stable:
  ICU 3.2

Reimplemented from RunArray.

Definition at line 492 of file RunArrays.h.

virtual void LocaleRuns::grow | ( | le_int32 | capacity | ) | `[protected, virtual]`

Grow a data array to the given initial size.

This method will be called by the `add` method if the limit indices array is full. Subclasses which override this method must also call it from the overriding method to grow the limit indices array.

Parameters:

  | capacity | is the initial size of the data array.

See also:
  add

Stable:
  ICU 3.2

Reimplemented from RunArray.

virtual void LocaleRuns::init | ( | le_int32 | capacity | ) | `[protected, virtual]`

Create a data array with the given initial size.

This method will be called by the `add` method if there is no limit indices array. Subclasses which override this method must also call it from the overriding method to create the limit indices array.

Parameters:

  | capacity | is the initial size of the data array.

See also:
  add

Stable:
  ICU 3.2

Reimplemented from RunArray.

## Field Documentation

const Locale** LocaleRuns::fLocales`[protected]`

Internal:
  Do not use. This API is for internal use only.

Definition at line 508 of file RunArrays.h.

The documentation for this class was generated from the following file:

- RunArrays.h